Index: trunk/src/VBox/Additions/WINNT/Installer/Languages/English.nsh
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/Languages/English.nsh	(revision 50399)
+++ trunk/src/VBox/Additions/WINNT/Installer/Languages/English.nsh	(revision 50401)
@@ -4,5 +4,5 @@
 
 ;
-; Copyright (C) 2006-2012 Oracle Corporation
+; Copyright (C) 2006-2014 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
@@ -15,22 +15,22 @@
 ;
 
-LangString VBOX_TEST ${LANG_ENGLISH}                     "This is a test message of $(^Name)!"
+LangString VBOX_TEST ${LANG_ENGLISH}                                "This is a test message of $(^Name)!"
 
-LangString VBOX_NOADMIN ${LANG_ENGLISH}                  "You need administrator rights to install or uninstall the $(^Name).$\r$\nThis application will exit now."
+LangString VBOX_NOADMIN ${LANG_ENGLISH}                             "You need administrator rights to install or uninstall the $(^Name).$\r$\nThis application will exit now."
 
-LangString VBOX_NOTICE_ARCH_X86 ${LANG_ENGLISH}          "This application only runs on 32-bit Windows systems. Please install the 64-bit version of $(^Name)!"
-LangString VBOX_NOTICE_ARCH_AMD64 ${LANG_ENGLISH}        "This application only runs on 64-bit Windows systems. Please install the 32-bit version of $(^Name)!"
-LangString VBOX_NT4_NO_SP6 ${LANG_ENGLISH}               "You do not seem to have Service Pack 6 for Windows NT4 installed.$\r$\nWe recommend that you install it first. Do you wish to continue anyway?"
+LangString VBOX_NOTICE_ARCH_X86 ${LANG_ENGLISH}                     "This application only runs on 32-bit Windows systems. Please install the 64-bit version of $(^Name)!"
+LangString VBOX_NOTICE_ARCH_AMD64 ${LANG_ENGLISH}                   "This application only runs on 64-bit Windows systems. Please install the 32-bit version of $(^Name)!"
+LangString VBOX_NT4_NO_SP6 ${LANG_ENGLISH}                          "You do not seem to have Service Pack 6 for Windows NT4 installed.$\r$\nWe recommend that you install it first. Do you wish to continue anyway?"
 
-LangString VBOX_PLATFORM_UNSUPPORTED ${LANG_ENGLISH}     "The VirtualBox Guest Additions cannot be installed on this version of Windows"
+LangString VBOX_PLATFORM_UNSUPPORTED ${LANG_ENGLISH}                "The VirtualBox Guest Additions cannot be installed on this version of Windows"
 
-LangString VBOX_SUN_FOUND ${LANG_ENGLISH}                "An old version of the Sun VirtualBox Guest Additions is installed in this virtual machine. This must be uninstalled before the current Guest Additions can be installed.$\r$\n$\r$\nDo you wish to uninstall the old Guest Additions now?"
-LangString VBOX_SUN_ABORTED ${LANG_ENGLISH}              "The VirtualBox Guest Additions cannot be installed until the old version has been removed.  Please remove it and try again."
+LangString VBOX_SUN_FOUND ${LANG_ENGLISH}                           "An old version of the Sun VirtualBox Guest Additions is installed in this virtual machine. This must be uninstalled before the current Guest Additions can be installed.$\r$\n$\r$\nDo you wish to uninstall the old Guest Additions now?"
+LangString VBOX_SUN_ABORTED ${LANG_ENGLISH}                         "The VirtualBox Guest Additions cannot be installed until the old version has been removed.  Please remove it and try again."
 
-LangString VBOX_INNOTEK_FOUND ${LANG_ENGLISH}            "An old version of the innotek VirtualBox Guest Additions is installed in this virtual machine. This must be uninstalled before the current Guest Additions can be installed.$\r$\n$\r$\nDo you wish to uninstall the old Guest Additions now?"
-LangString VBOX_INNOTEK_ABORTED ${LANG_ENGLISH}          "The VirtualBox Guest Additions cannot be installed until the old version has been removed.  Please remove it and try again."
+LangString VBOX_INNOTEK_FOUND ${LANG_ENGLISH}                       "An old version of the innotek VirtualBox Guest Additions is installed in this virtual machine. This must be uninstalled before the current Guest Additions can be installed.$\r$\n$\r$\nDo you wish to uninstall the old Guest Additions now?"
+LangString VBOX_INNOTEK_ABORTED ${LANG_ENGLISH}                     "The VirtualBox Guest Additions cannot be installed until the old version has been removed.  Please remove it and try again."
 
-LangString VBOX_UNINSTALL_START ${LANG_ENGLISH}          "Press OK to start the uninstallation process. This may take some time to complete."
-LangString VBOX_UNINSTALL_REBOOT ${LANG_ENGLISH}         "It is strongly recommended that you restart this virtual machine before installing the new version of the VirtualBox Guest Additions.$\r$\nPlease start the installation process again after restarting the machine.$\r$\n$\r$\nRestart now?"
+LangString VBOX_UNINSTALL_START ${LANG_ENGLISH}                     "Press OK to start the uninstallation process. This may take some time to complete."
+LangString VBOX_UNINSTALL_REBOOT ${LANG_ENGLISH}                    "It is strongly recommended that you restart this virtual machine before installing the new version of the VirtualBox Guest Additions.$\r$\nPlease start the installation process again after restarting the machine.$\r$\n$\r$\nRestart now?"
 
 LangString VBOX_COMPONENT_MAIN ${LANG_ENGLISH}                      "VirtualBox Guest Additions"
@@ -48,14 +48,14 @@
 LangString VBOX_COMPONENT_D3D_INVALID_MANUAL ${LANG_ENGLISH}        "Shall the VirtualBox manual be displayed now to look for a solution?"
 
-LangString VBOX_WFP_WARN_REPLACE ${LANG_ENGLISH}         "In order to make ${PRODUCT_NAME} work correctly some system files have been replaced.$\r$\nIf the Windows File Protection service offers to restore the original files you should cancel the request to retain the newly installed functionality."
-LangString VBOX_REBOOT_REQUIRED ${LANG_ENGLISH}          "To apply all changes, the system must be restarted. Restart Windows now?"
+LangString VBOX_WFP_WARN_REPLACE ${LANG_ENGLISH}                    "In order to make ${PRODUCT_NAME} work correctly some system files have been replaced.$\r$\nIf the Windows File Protection service offers to restore the original files you should cancel the request to retain the newly installed functionality."
+LangString VBOX_REBOOT_REQUIRED ${LANG_ENGLISH}                     "To apply all changes, the system must be restarted. Restart Windows now?"
 
-LangString VBOX_EXTRACTION_COMPLETE ${LANG_ENGLISH}      "$(^Name): Files were successfully extracted to $\"$INSTDIR$\"!"
+LangString VBOX_EXTRACTION_COMPLETE ${LANG_ENGLISH}                 "$(^Name): Files were successfully extracted to $\"$INSTDIR$\"!"
 
-LangString VBOX_ERROR_INST_FAILED ${LANG_ENGLISH}        "An error occurred during installation.$\r$\nPlease refer to the log file under '$INSTDIR\install_ui.log' for more information."
-LangString VBOX_ERROR_OPEN_LINK ${LANG_ENGLISH}          "Could not open link in the default browser."
+LangString VBOX_ERROR_INST_FAILED ${LANG_ENGLISH}                   "An error occurred during installation.$\r$\nPlease refer to the log file under '$INSTDIR\install_ui.log' for more information."
+LangString VBOX_ERROR_OPEN_LINK ${LANG_ENGLISH}                     "Could not open link in the default browser."
 
-LangString VBOX_UNINST_CONFIRM ${LANG_ENGLISH}           "Do you really want to uninstall $(^Name)?"
-LangString VBOX_UNINST_SUCCESS ${LANG_ENGLISH}           "$(^Name) have been uninstalled."
-LangString VBOX_UNINST_INVALID_D3D ${LANG_ENGLISH}       "Invalid installation of Direct3D support detected; uninstallation skipped."
-
+LangString VBOX_UNINST_CONFIRM ${LANG_ENGLISH}                      "Do you really want to uninstall $(^Name)?"
+LangString VBOX_UNINST_SUCCESS ${LANG_ENGLISH}                      "$(^Name) have been uninstalled."
+LangString VBOX_UNINST_INVALID_D3D ${LANG_ENGLISH}                  "Invalid installation of Direct3D support detected; uninstallation skipped."
+LangString VBOX_UNINST_UNABLE_TO_RESTORE_D3D ${LANG_ENGLISH}        "Could not restore original Direct3D files. Please re-install DirectX."
Index: trunk/src/VBox/Additions/WINNT/Installer/Languages/French.nsh
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/Languages/French.nsh	(revision 50399)
+++ trunk/src/VBox/Additions/WINNT/Installer/Languages/French.nsh	(revision 50401)
@@ -4,5 +4,5 @@
 
 ;
-; Copyright (C) 2006-2012 Oracle Corporation
+; Copyright (C) 2006-2014 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
@@ -15,22 +15,22 @@
 ;
 
-LangString VBOX_TEST ${LANG_FRENCH}                      "Ceci est un message de test de $(^Name)!"
+LangString VBOX_TEST ${LANG_FRENCH}                                 "Ceci est un message de test de $(^Name)!"
 
-LangString VBOX_NOADMIN ${LANG_FRENCH}                   "Vous avez besoin de droits d'administrateur pour (dés)installer $(^Name)!$\r$\nCe programme d'installation se terminera maintenant."
+LangString VBOX_NOADMIN ${LANG_FRENCH}                              "Vous avez besoin de droits d'administrateur pour (dés)installer $(^Name)!$\r$\nCe programme d'installation se terminera maintenant."
 
-LangString VBOX_NOTICE_ARCH_X86 ${LANG_FRENCH}           "Cette application peut seulement être executée sur des systèmes Windows 32-bit. Veuillez installer la version 64-bit de $(^Name)!"
-LangString VBOX_NOTICE_ARCH_AMD64 ${LANG_FRENCH}         "Cette application peut seulement être executée sur des systèmes Windows 64-bit. Veuillez installer la version 32-bit de $(^Name)!"
-LangString VBOX_NT4_NO_SP6 ${LANG_FRENCH}                "Le programme d'installation a détécté que vous utilisez Windows NT4 sans Service Pack 6.$\r$\nNous vous conseillons d'installer ce Service Pack avant de continuer. Désirez vous cependant continuer?"
+LangString VBOX_NOTICE_ARCH_X86 ${LANG_FRENCH}                      "Cette application peut seulement être executée sur des systèmes Windows 32-bit. Veuillez installer la version 64-bit de $(^Name)!"
+LangString VBOX_NOTICE_ARCH_AMD64 ${LANG_FRENCH}                    "Cette application peut seulement être executée sur des systèmes Windows 64-bit. Veuillez installer la version 32-bit de $(^Name)!"
+LangString VBOX_NT4_NO_SP6 ${LANG_FRENCH}                           "Le programme d'installation a détécté que vous utilisez Windows NT4 sans Service Pack 6.$\r$\nNous vous conseillons d'installer ce Service Pack avant de continuer. Désirez vous cependant continuer?"
 
-LangString VBOX_PLATFORM_UNSUPPORTED ${LANG_FRENCH}      "Les Additions invité ne sont pas encore supportés sur cette plateforme!"
+LangString VBOX_PLATFORM_UNSUPPORTED ${LANG_FRENCH}                 "Les Additions invité ne sont pas encore supportés sur cette plateforme!"
 
-LangString VBOX_SUN_FOUND ${LANG_FRENCH}                 "Une ancienne version des Additions invité Sun est installée dans cette machine virtuelle. Les Additions invité actuelles ne peuvent être installées avant que cette version ne soit désinstallée.$\r$\n$\r$\nVoulez-vous désinstaller l'ancienne version maintenant?"
-LangString VBOX_SUN_ABORTED ${LANG_FRENCH}               "Le programme ne peut pas continuer avec l'installation des Additions invité.$\r$\nVeuillez désinstaller d'abord les anciennes Additions Sun!"
+LangString VBOX_SUN_FOUND ${LANG_FRENCH}                            "Une ancienne version des Additions invité Sun est installée dans cette machine virtuelle. Les Additions invité actuelles ne peuvent être installées avant que cette version ne soit désinstallée.$\r$\n$\r$\nVoulez-vous désinstaller l'ancienne version maintenant?"
+LangString VBOX_SUN_ABORTED ${LANG_FRENCH}                          "Le programme ne peut pas continuer avec l'installation des Additions invité.$\r$\nVeuillez désinstaller d'abord les anciennes Additions Sun!"
 
-LangString VBOX_INNOTEK_FOUND ${LANG_FRENCH}             "Une ancienne version des Additions invité est installée dans cette machine virtuelle. Les Additions invité actuelles ne peuvent être installées avant que cette version ne soit désinstallée.$\r$\n$\r$\nVoulez-vous désinstaller l'ancienne version maintenant?"
-LangString VBOX_INNOTEK_ABORTED ${LANG_FRENCH}           "Le programme ne peut pas continuer avec l'installation des Additions invité.$\r$\nVeuillez désinstaller d'abord les anciennes Additions!"
+LangString VBOX_INNOTEK_FOUND ${LANG_FRENCH}                        "Une ancienne version des Additions invité est installée dans cette machine virtuelle. Les Additions invité actuelles ne peuvent être installées avant que cette version ne soit désinstallée.$\r$\n$\r$\nVoulez-vous désinstaller l'ancienne version maintenant?"
+LangString VBOX_INNOTEK_ABORTED ${LANG_FRENCH}                      "Le programme ne peut pas continuer avec l'installation des Additions invité.$\r$\nVeuillez désinstaller d'abord les anciennes Additions!"
 
-LangString VBOX_UNINSTALL_START ${LANG_FRENCH}           "Choisissez OK pour démarrer la désinstallation.$\r$\nLe processus nécessitera quelque temps et se déroulera en arrière-plan."
-LangString VBOX_UNINSTALL_REBOOT ${LANG_FRENCH}          "Nous vous conseillons fortement de redémarer cette machine virtuelle avant d'installer la nouvelle version des Additions invité.$\r$\nVeuillez recommencer l'installation des Additions après le redémarrage.$\r$\n$\r$\nRedémarrer maintenant?"
+LangString VBOX_UNINSTALL_START ${LANG_FRENCH}                      "Choisissez OK pour démarrer la désinstallation.$\r$\nLe processus nécessitera quelque temps et se déroulera en arrière-plan."
+LangString VBOX_UNINSTALL_REBOOT ${LANG_FRENCH}                     "Nous vous conseillons fortement de redémarer cette machine virtuelle avant d'installer la nouvelle version des Additions invité.$\r$\nVeuillez recommencer l'installation des Additions après le redémarrage.$\r$\n$\r$\nRedémarrer maintenant?"
 
 LangString VBOX_COMPONENT_MAIN ${LANG_FRENCH}                       "Additions invité VirtualBox"
@@ -48,14 +48,14 @@
 LangString VBOX_COMPONENT_D3D_INVALID_MANUAL ${LANG_FRENCH}         "Voulez-vous voir le manuel d'utilisateur VirtualBox pour chercher une solution?"
 
-LangString VBOX_WFP_WARN_REPLACE ${LANG_FRENCH}          "Le programme d'installation vient de remplacer certains fichiers systèmes afin de faire fonctionner correctement ${PRODUCT_NAME}.$\r$\nPour le cas qu'un avertissement de la Protection de fichiers Windows apparaisse, veuiller l'annuler sans restaurer les fichiers originaux!"
-LangString VBOX_REBOOT_REQUIRED ${LANG_FRENCH}           "Le système doit être redémarré pourque les changements prennent effet. Redémarrer Windows maintenant?"
+LangString VBOX_WFP_WARN_REPLACE ${LANG_FRENCH}                     "Le programme d'installation vient de remplacer certains fichiers systèmes afin de faire fonctionner correctement ${PRODUCT_NAME}.$\r$\nPour le cas qu'un avertissement de la Protection de fichiers Windows apparaisse, veuiller l'annuler sans restaurer les fichiers originaux!"
+LangString VBOX_REBOOT_REQUIRED ${LANG_FRENCH}                      "Le système doit être redémarré pourque les changements prennent effet. Redémarrer Windows maintenant?"
 
-LangString VBOX_EXTRACTION_COMPLETE ${LANG_FRENCH}       "$(^Name): Les fichiers ont été extrait avec succès dans $\"$INSTDIR$\"!"
+LangString VBOX_EXTRACTION_COMPLETE ${LANG_FRENCH}                  "$(^Name): Les fichiers ont été extrait avec succès dans $\"$INSTDIR$\"!"
 
-LangString VBOX_ERROR_INST_FAILED ${LANG_FRENCH}         "Une erreur est survenue pendant l'installation!$\r$\nVeuillez consulter le fichier log '$INSTDIR\install_ui.log' pour plus d'informations."
-LangString VBOX_ERROR_OPEN_LINK ${LANG_FRENCH}           "Impossible d'ouvrir le lien dans le navigateur par defaut."
+LangString VBOX_ERROR_INST_FAILED ${LANG_FRENCH}                    "Une erreur est survenue pendant l'installation!$\r$\nVeuillez consulter le fichier log '$INSTDIR\install_ui.log' pour plus d'informations."
+LangString VBOX_ERROR_OPEN_LINK ${LANG_FRENCH}                      "Impossible d'ouvrir le lien dans le navigateur par defaut."
 
-LangString VBOX_UNINST_CONFIRM ${LANG_FRENCH}            "Voulez-vous vraiment désinstaller $(^Name)?"
-LangString VBOX_UNINST_SUCCESS ${LANG_FRENCH}            "$(^Name) ont été désinstallés."
-LangString VBOX_UNINST_INVALID_D3D ${LANG_FRENCH}        "Installation incorrecte du support Direct3D detectée; une désinstallation ne sera pas tentée."
-
+LangString VBOX_UNINST_CONFIRM ${LANG_FRENCH}                       "Voulez-vous vraiment désinstaller $(^Name)?"
+LangString VBOX_UNINST_SUCCESS ${LANG_FRENCH}                       "$(^Name) ont été désinstallés."
+LangString VBOX_UNINST_INVALID_D3D ${LANG_FRENCH}                   "Installation incorrecte du support Direct3D detectée; une désinstallation ne sera pas tentée."
+LangString VBOX_UNINST_UNABLE_TO_RESTORE_D3D ${LANG_FRENCH}         "Could not restore original Direct3D files. Please re-install DirectX."
Index: trunk/src/VBox/Additions/WINNT/Installer/Languages/German.nsh
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/Languages/German.nsh	(revision 50399)
+++ trunk/src/VBox/Additions/WINNT/Installer/Languages/German.nsh	(revision 50401)
@@ -4,5 +4,5 @@
 
 ;
-; Copyright (C) 2006-2012 Oracle Corporation
+; Copyright (C) 2006-2014 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
@@ -15,22 +15,22 @@
 ;
 
-LangString VBOX_TEST ${LANG_GERMAN}                     "Das ist eine Test-Nachricht von $(^Name)!"
+LangString VBOX_TEST ${LANG_GERMAN}                                 "Das ist eine Test-Nachricht von $(^Name)!"
 
-LangString VBOX_NOADMIN ${LANG_GERMAN}                  "Sie benötigen Administrations-Rechte zum (De-)Installieren der $(^Name)!$\r$\nDas Setup wird nun beendet."
+LangString VBOX_NOADMIN ${LANG_GERMAN}                              "Sie benötigen Administrations-Rechte zum (De-)Installieren der $(^Name)!$\r$\nDas Setup wird nun beendet."
 
-LangString VBOX_NOTICE_ARCH_X86 ${LANG_GERMAN}          "Diese Applikation läuft nur auf 32-bit Windows-Systemen. Bitte installieren Sie die 64-bit Version der $(^Name)!"
-LangString VBOX_NOTICE_ARCH_AMD64 ${LANG_GERMAN}        "Diese Applikation läuft nur auf 64-bit Windows-Systemen. Bitte installieren Sie die 32-bit Version der $(^Name)!"
-LangString VBOX_NT4_NO_SP6 ${LANG_GERMAN}               "Es ist kein Service Pack 6 für NT 4.0 installiert.$\r$\nEs wird empfohlen das Service-Pack vor dieser Installation zu installieren. Trotzdem jetzt ohne Service-Pack installieren?"
+LangString VBOX_NOTICE_ARCH_X86 ${LANG_GERMAN}                      "Diese Applikation läuft nur auf 32-bit Windows-Systemen. Bitte installieren Sie die 64-bit Version der $(^Name)!"
+LangString VBOX_NOTICE_ARCH_AMD64 ${LANG_GERMAN}                    "Diese Applikation läuft nur auf 64-bit Windows-Systemen. Bitte installieren Sie die 32-bit Version der $(^Name)!"
+LangString VBOX_NT4_NO_SP6 ${LANG_GERMAN}                           "Es ist kein Service Pack 6 für NT 4.0 installiert.$\r$\nEs wird empfohlen das Service-Pack vor dieser Installation zu installieren. Trotzdem jetzt ohne Service-Pack installieren?"
 
-LangString VBOX_PLATFORM_UNSUPPORTED ${LANG_GERMAN}     "Diese Plattform wird noch nicht durch diese Guest Additions unterstützt!"
+LangString VBOX_PLATFORM_UNSUPPORTED ${LANG_GERMAN}                 "Diese Plattform wird noch nicht durch diese Guest Additions unterstützt!"
 
-LangString VBOX_SUN_FOUND ${LANG_GERMAN}                "Eine veraltete Version der Sun Guest Additions ist auf diesem System bereits installiert. Diese muss erst deinstalliert werden bevor aktuelle Guest Additions installiert werden können.$\r$\n$\r$\nJetzt die alten Guest Additions deinstallieren?"
-LangString VBOX_SUN_ABORTED ${LANG_GERMAN}              "Die Installation der Guest Additions kann nicht fortgesetzt werden.$\r$\nBitte deinstallieren Sie erst die alten Sun Guest Additions!"
+LangString VBOX_SUN_FOUND ${LANG_GERMAN}                            "Eine veraltete Version der Sun Guest Additions ist auf diesem System bereits installiert. Diese muss erst deinstalliert werden bevor aktuelle Guest Additions installiert werden können.$\r$\n$\r$\nJetzt die alten Guest Additions deinstallieren?"
+LangString VBOX_SUN_ABORTED ${LANG_GERMAN}                          "Die Installation der Guest Additions kann nicht fortgesetzt werden.$\r$\nBitte deinstallieren Sie erst die alten Sun Guest Additions!"
 
-LangString VBOX_INNOTEK_FOUND ${LANG_GERMAN}            "Eine veraltete Version der innotek Guest Additions ist auf diesem System bereits installiert. Diese muss erst deinstalliert werden bevor aktuelle Guest Additions installiert werden können.$\r$\n$\r$\nJetzt die alten Guest Additions deinstallieren?"
-LangString VBOX_INNOTEK_ABORTED ${LANG_GERMAN}          "Die Installation der Guest Additions kann nicht fortgesetzt werden.$\r$\nBitte deinstallieren Sie erst die alten innotek Guest Additions!"
+LangString VBOX_INNOTEK_FOUND ${LANG_GERMAN}                        "Eine veraltete Version der innotek Guest Additions ist auf diesem System bereits installiert. Diese muss erst deinstalliert werden bevor aktuelle Guest Additions installiert werden können.$\r$\n$\r$\nJetzt die alten Guest Additions deinstallieren?"
+LangString VBOX_INNOTEK_ABORTED ${LANG_GERMAN}                      "Die Installation der Guest Additions kann nicht fortgesetzt werden.$\r$\nBitte deinstallieren Sie erst die alten innotek Guest Additions!"
 
-LangString VBOX_UNINSTALL_START ${LANG_GERMAN}          "Auf OK klicken um mit der Deinstallation zu beginnen.$\r$\nBitte warten Sie dann während die Deinstallation im Hintergrund ausgeführt wird ..."
-LangString VBOX_UNINSTALL_REBOOT ${LANG_GERMAN}         "Es wird dringend empfohlen das System neu zu starten bevor die neuen Guest Additions installiert werden.$\r$\nBitte starten Sie die Installation nach dem Neustart erneut.$\r$\n$\r$\nJetzt neu starten?"
+LangString VBOX_UNINSTALL_START ${LANG_GERMAN}                      "Auf OK klicken um mit der Deinstallation zu beginnen.$\r$\nBitte warten Sie dann während die Deinstallation im Hintergrund ausgeführt wird ..."
+LangString VBOX_UNINSTALL_REBOOT ${LANG_GERMAN}                     "Es wird dringend empfohlen das System neu zu starten bevor die neuen Guest Additions installiert werden.$\r$\nBitte starten Sie die Installation nach dem Neustart erneut.$\r$\n$\r$\nJetzt neu starten?"
 
 LangString VBOX_COMPONENT_MAIN ${LANG_GERMAN}                       "VirtualBox Guest Additions"
@@ -48,14 +48,14 @@
 LangString VBOX_COMPONENT_D3D_INVALID_MANUAL ${LANG_GERMAN}         "Soll nun das VirtualBox-Handbuch angezeigt werden um nach einer Lösung zu suchen?"
 
-LangString VBOX_WFP_WARN_REPLACE ${LANG_GERMAN}         "Das Setup hat gerade Systemdateien ersetzt um die ${PRODUCT_NAME} korrekt installieren zu können.$\r$\nFalls nun ein Warn-Dialog des Windows-Dateischutzes erscheint, diesen bitte abbrechen und die Dateien nicht wiederherstellen lassen!"
-LangString VBOX_REBOOT_REQUIRED ${LANG_GERMAN}          "Um alle Änderungen durchführen zu können, muss das System neu gestartet werden. Jetzt neu starten?"
+LangString VBOX_WFP_WARN_REPLACE ${LANG_GERMAN}                     "Das Setup hat gerade Systemdateien ersetzt um die ${PRODUCT_NAME} korrekt installieren zu können.$\r$\nFalls nun ein Warn-Dialog des Windows-Dateischutzes erscheint, diesen bitte abbrechen und die Dateien nicht wiederherstellen lassen!"
+LangString VBOX_REBOOT_REQUIRED ${LANG_GERMAN}                      "Um alle Änderungen durchführen zu können, muss das System neu gestartet werden. Jetzt neu starten?"
 
-LangString VBOX_EXTRACTION_COMPLETE ${LANG_GERMAN}      "$(^Name): Die Dateien wurden erfolgreich nach $\"$INSTDIR$\" entpackt!"
+LangString VBOX_EXTRACTION_COMPLETE ${LANG_GERMAN}                  "$(^Name): Die Dateien wurden erfolgreich nach $\"$INSTDIR$\" entpackt!"
 
-LangString VBOX_ERROR_INST_FAILED ${LANG_GERMAN}        "Es trat ein Fehler während der Installation auf!$\r$\nBitte werfen Sie einen Blick in die Log-Datei unter '$INSTDIR\install_ui.log' für mehr Informationen."
-LangString VBOX_ERROR_OPEN_LINK ${LANG_GERMAN}          "Link konnte nicht im Standard-Browser geöffnet werden."
+LangString VBOX_ERROR_INST_FAILED ${LANG_GERMAN}                    "Es trat ein Fehler während der Installation auf!$\r$\nBitte werfen Sie einen Blick in die Log-Datei unter '$INSTDIR\install_ui.log' für mehr Informationen."
+LangString VBOX_ERROR_OPEN_LINK ${LANG_GERMAN}                      "Link konnte nicht im Standard-Browser geöffnet werden."
 
-LangString VBOX_UNINST_CONFIRM ${LANG_GERMAN}           "Wollen Sie wirklich die $(^Name) deinstallieren?"
-LangString VBOX_UNINST_SUCCESS ${LANG_GERMAN}           "$(^Name) wurden erfolgreich deinstalliert."
-LangString VBOX_UNINST_INVALID_D3D ${LANG_GERMAN}       "Unvollständige oder ungültige Installation der Direct3D-Unterstützung erkannt; Deinstallation wird übersprungen."
-
+LangString VBOX_UNINST_CONFIRM ${LANG_GERMAN}                       "Wollen Sie wirklich die $(^Name) deinstallieren?"
+LangString VBOX_UNINST_SUCCESS ${LANG_GERMAN}                       "$(^Name) wurden erfolgreich deinstalliert."
+LangString VBOX_UNINST_INVALID_D3D ${LANG_GERMAN}                   "Unvollständige oder ungültige Installation der Direct3D-Unterstützung erkannt; Deinstallation wird übersprungen."
+LangString VBOX_UNINST_UNABLE_TO_RESTORE_D3D ${LANG_GERMAN}         "Konnte Direct3D-Originaldateien nicht wiederherstellen. Bitte DirectX neu installieren."
Index: trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditions.nsi
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditions.nsi	(revision 50399)
+++ trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditions.nsi	(revision 50401)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2012-2013 Oracle Corporation
+; Copyright (C) 2012-2014 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
@@ -827,5 +827,8 @@
 !if $%VBOX_WITH_WDDM% == "1"
   ${If} $g_bWithWDDM == "true"
-    ; All D3D components are installed with WDDM driver package, nothing to be done here
+    ; Do we need to restore the original d3d8.dll/d3d9.dll files because the guest
+    ; installation was upgraded from XPDM to WDDM driver? In a XPDM installation
+    ; those DLLs were replaced by our own stub files.
+    Call RestoreFilesDirect3D
     Return
   ${EndIf}
@@ -1250,5 +1253,5 @@
     !insertmacro SelectSection ${SEC03}
   ${EndIf}
-  ; On Windows 8 / 8.1 / Windows Server 2012 R2 we always select the 3D 
+  ; On Windows 8 / 8.1 / Windows Server 2012 R2 we always select the 3D
   ; section and disable it so that it cannot be deselected again
   ${If}   $g_strWinVersion == "8"
Index: trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsCommon.nsh
===================================================================
--- trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsCommon.nsh	(revision 50399)
+++ trunk/src/VBox/Additions/WINNT/Installer/VBoxGuestAdditionsCommon.nsh	(revision 50401)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2006-2013 Oracle Corporation
+; Copyright (C) 2006-2014 Oracle Corporation
 ;
 ; This file is part of VirtualBox Open Source Edition (OSE), as
@@ -1019,2 +1019,60 @@
 !insertmacro ValidateFilesDirect3D ""
 !insertmacro ValidateFilesDirect3D "un."
+
+;
+; Restores formerly backed up Direct3D original files, which were replaced by
+; a VBox XPDM driver installation before. This might be necessary for upgrading a
+; XPDM installation to a WDDM one.
+; @return  Stack: "0" if files were restored successfully; otherwise "1".
+;
+!macro RestoreFilesDirect3D un
+Function ${un}RestoreFilesDirect3D
+
+  Push $0
+
+  ; We need to switch to 64-bit app mode to handle the "real" 64-bit files in
+  ; ""system32" on a 64-bit guest
+  Call ${un}SetAppMode64
+
+  ; Note: Not finding a file (like *d3d8.dll) on Windows Vista/7 is fine;
+  ;       it simply is not present there.
+
+  ; Note 2: On 64-bit systems there are no 64-bit *d3d8 DLLs, only 32-bit ones
+  ;         in SysWOW64 (or in system32 on 32-bit systems).
+
+!if $%BUILD_TARGET_ARCH% == "x86"
+  ${CopyFileEx} "${un}" "$SYSDIR\msd3d8.dll" "$SYSDIR\d3d8.dll" "Microsoft Corporation" "$%BUILD_TARGET_ARCH%"
+!endif
+  ${CopyFileEx} "${un}" "$SYSDIR\msd3d9.dll" "$SYSDIR\d3d9.dll" "Microsoft Corporation" "$%BUILD_TARGET_ARCH%"
+
+  ${If} $g_bCapDllCache == "true"
+!if $%BUILD_TARGET_ARCH% == "x86"
+    ${CopyFileEx} "${un}" "$SYSDIR\dllcache\msd3d8.dll" "$SYSDIR\dllcache\d3d8.dll" "Microsoft Corporation" "$%BUILD_TARGET_ARCH%"
+!endif
+    ${CopyFileEx} "${un}" "$SYSDIR\dllcache\msd3d9.dll" "$SYSDIR\dllcache\d3d9.dll" "Microsoft Corporation" "$%BUILD_TARGET_ARCH%"
+  ${EndIf}
+
+!if $%BUILD_TARGET_ARCH% == "amd64"
+  ${CopyFileEx} "${un}" "$g_strSysWow64\msd3d8.dll" "$g_strSysWow64\d3d8.dll" "Microsoft Corporation" "$%BUILD_TARGET_ARCH%"
+  ${CopyFileEx} "${un}" "$g_strSysWow64\msd3d9.dll" "$g_strSysWow64\d3d9.dll" "Microsoft Corporation" "$%BUILD_TARGET_ARCH%"
+
+  ${If} $g_bCapDllCache == "true"
+    ${CopyFileEx} "${un}" "$g_strSysWow64\dllcache\msd3d8.dll" "$g_strSysWow64\dllcache\d3d8.dll" "Microsoft Corporation" "$%BUILD_TARGET_ARCH%"
+    ${CopyFileEx} "${un}" "$g_strSysWow64\dllcache\msd3d9.dll" "$g_strSysWow64\dllcache\d3d9.dll" "Microsoft Corporation" "$%BUILD_TARGET_ARCH%"
+  ${EndIf}
+!endif
+
+  ; Do a re-validation afterwards.
+  Call ${un}ValidateD3DFiles
+  Pop $0
+  ${If} $0 == "1" ; D3D files are invalid
+    ${LogVerbose} $(VBOX_UNINST_UNABLE_TO_RESTORE_D3D)
+    MessageBox MB_ICONSTOP|MB_OK $(VBOX_UNINST_UNABLE_TO_RESTORE_D3D) /SD IDOK
+  ${EndIf}
+
+  Exch $0
+
+FunctionEnd
+!macroend
+!insertmacro RestoreFilesDirect3D ""
+!insertmacro RestoreFilesDirect3D "un."